Attribute VB_Name = "modChooseColor"
Option Explicit


Public Sub DrawLuminanceBox(ByRef picThis As PictureBox, ByVal h As Single, ByVal s As Single)

Dim r As Long, g As Long, b As Long
Dim lHDC As Long
Dim tR As RECT
Dim lColor As Long
Dim hBr As Long
Dim l As Long
   
   lHDC = picThis.hdc
   tR.Right = picThis.ScaleWidth \ Screen.TwipsPerPixelX
   tR.Bottom = 1
   For l = 255 To 0 Step -1
      HLSToRGB h, s, l / 255, r, g, b
      hBr = CreateSolidBrush(RGB(r, g, b))
      FillRect lHDC, tR, hBr
      DeleteObject hBr
      tR.Top = tR.Top + 1
      tR.Bottom = tR.Bottom + 1
   Next l
   picThis.Refresh
   
End Sub


Private Sub RGBToHSL(r As Long, g As Long, b As Long, h As Single, s As Single, l As Single)

Dim Max As Single
Dim Min As Single
Dim delta As Single
Dim rR As Single, rG As Single, rB As Single

   rR = r / 255: rG = g / 255: rB = b / 255

        Max = Maximum(rR, rG, rB)
        Min = Minimum(rR, rG, rB)
        l = (Max + Min) / 2
        If Max = Min Then
            s = 0
            h = 0
        Else
           If l <= 0.5 Then
               s = (Max - Min) / (Max + Min)
           Else
               s = (Max - Min) / (2 - Max - Min)
            End If
            delta = Max - Min
           If rR = Max Then
                h = (rG - rB) / delta
           ElseIf rG = Max Then
                h = 2 + (rB - rR) / delta
           ElseIf rB = Max Then
                h = 4 + (rR - rG) / delta
            End If
      End If
      
End Sub

Public Sub HLSToRGB(h As Single, s As Single, l As Single, r As Long, g As Long, b As Long)

Dim rR As Single, rG As Single, rB As Single
Dim Min As Single, Max As Single

   If s = 0 Then
      rR = l: rG = l: rB = l
   Else
      If l <= 0.5 Then
         Min = l * (1 - s)
      Else
         Min = l - s * (1 - l)
      End If
      Max = 2 * l - Min
      If (h < 1) Then
         rR = Max
         If (h < 0) Then
            rG = Min
            rB = rG - h * (Max - Min)
         Else
            rB = Min
            rG = h * (Max - Min) + rB
         End If
      ElseIf (h < 3) Then
         rG = Max
         If (h < 2) Then
            rB = Min
            rR = rB - (h - 2) * (Max - Min)
         Else
            rR = Min
            rB = (h - 2) * (Max - Min) + rR
         End If
      Else
         rB = Max
         If (h < 4) Then
            rR = Min
            rG = rR - (h - 4) * (Max - Min)
         Else
            rG = Min
            rR = (h - 4) * (Max - Min) + rG
         End If
         
      End If
            
   End If
   r = rR * 255: g = rG * 255: b = rB * 255
   
End Sub

Private Function Maximum(rR As Single, rG As Single, rB As Single) As Single

   If (rR > rG) Then
      If (rR > rB) Then
         Maximum = rR
      Else
         Maximum = rB
      End If
   Else
      If (rB > rG) Then
         Maximum = rB
      Else
         Maximum = rG
      End If
   End If
   
End Function

Private Function Minimum(rR As Single, rG As Single, rB As Single) As Single

   If (rR < rG) Then
      If (rR < rB) Then
         Minimum = rR
      Else
         Minimum = rB
      End If
   Else
      If (rB < rG) Then
         Minimum = rB
      Else
         Minimum = rG
      End If
   End If
   
End Function

