Attribute VB_Name = "modMain"
Option Explicit

Private Declare Function GetSystemDirectoryA Lib "kernel32" (ByVal lpBuffer As String, ByVal nSize As Long) As Long


Sub Main()

On Error GoTo errError

    Dim hdc As Long, RetVal As Long
    Dim nBitsPerPixel As Integer

    hdc = GetDC(0)
    nBitsPerPixel = GetDeviceCaps(hdc, BITSPIXEL) * GetDeviceCaps(hdc, PLANES)
    RetVal = ReleaseDC(0, hdc)

    strWinDir = Environ("WinDir")
    
    With Screen
        If 2 ^ nBitsPerPixel < 65536 Then 'Farbauflsung prfen
            MsgBox "Nyrox Paint kann auf Ihrem System nicht ausgefrht werden, da Ihre Bildschirm-Farbtiefe auf weniger als 16Bit eingestellt ist. Nyrox Paint bentigt fr eine korrekte Ausfhrung mindestens 16Bit.", vbCritical + vbOKOnly, "Fehler:"
                End
        ElseIf (.Width / .TwipsPerPixelX) * (.Height / .TwipsPerPixelY) < 480000 Then
            MsgBox "Nyrox Paint kann auf Ihrem System nicht ausgefhrt werden, da Ihre Auflsung " & .Width / .TwipsPerPixelX & "*" & .Height / .TwipsPerPixelY & " Pixeln betrgt. Nyrox Paint setzt aber eine Auflsung von 800*600 Pixeln voraus. Stellen Sie bitte Ihre Auflsung hher und starten das Programm erneut.", vbCritical + vbOKOnly, "Fehler:"
                End
        ElseIf App.PrevInstance = True Then
            MsgBox "Sie versuchen Nyrox Paint zu starten, obwohl noch eine andere Sitzung von Nyrox Paint im Hintergrund aktive ist. Bitte beenden Sie erst die alte Sitzung, bevor Sie einen neue beginnnen.", vbCritical + vbOKOnly, "Fehler:"
                End
        Else
            Call ReadINIFile
            Call SetDefaults
        End If
    End With
    
    If CheckSystemFiles = False Then
        MsgBox "In Ihrem System-Verzeichniss wurde eine wichtige Systemdatei nicht gefunden. Bitte prfen Sie nach, ob Sie folgende Dateien haben: " & _
        vbCrLf & "" & _
        vbCrLf & "comdlg32.dll" & _
        vbCrLf & "gdi32.dll" & _
        vbCrLf & "user32.dll" & _
        vbCrLf & "rasapi32.dll" & _
        vbCrLf & "shell32.dll" & _
        vbCrLf, vbCritical, "Programm wird beendet."
            End
    End If

    strParameter = Command

    If Left(Command, 5) = "\full" Then
            If strParameter = "-NoOS" Then Exit Sub
            If Dir(strParameter) = "" Then
                MsgBox "Sie haben einen ungltigen Parameter eingegeben." & vbCrLf & "Nyrox Paint wird ohne Vernderung gestarten. Mgliche Parameter schauen Sie bitte unter der Hilfe nach.", vbCritical, "Fehler:"
            Else
                strFullScreenPath = strParameter
                    frmFullScreen.Show
                        Exit Sub
            End If
    End If

    If Dir(strWinDir & "\NyroxPaint.ico") = "" Then
        If Dir(App.Path & "\Icon.ico") = "" Then
            MsgBox "Die Icondatei 'Icon.ico' konnte im Nyrox Paint Verzeichnis nicht gefunden werden.", vbCritical, "Fehler:"
        Else
            FileCopy App.Path & "\Icon.ico", strWinDir & "\NyroxPaint.ico"
        End If
    End If
    
    If LCase(App.EXEName) <> "nyrox paint" And LCase(App.EXEName) <> "nyroxpaint" Then
        MsgBox "Die Nyrox Paint Exe-Datei wurde umbenannt. Bitte benennen Sie die Datei wider in 'Nyrox Paint.exe' um.", vbCritical, "Fehler:"
            End
    End If

    If QueryValue(HKEY_LOCAL_MACHINE, "Software\Nyrox\Paint", "Starts") = "" Then
        frmFirstStart.Show
        Call SetRegistrySettings
        Exit Sub
    Else
    End If
       
    Call SetRegistrySettings
    
    If Left(Date, 5) = "23.07" Then blnBirthday = True
    
    If typINIValue.bytShowSplash = 1 Then
        frmSplash.Show
    Else
        mdiMain.Show
    End If

    Exit Sub
    
errError:
    MsgBox "Es ist ein Fehler beim Laden von Nyrox Paint aufgetreten. Das Programm wird vorischtshalber beendet.", vbCritical, "Fehler:"
        End

End Sub

Private Sub SetDefaults()

    bytSprayRadius = 10
    bytSubPaintNumber = 1
    intBrushWidth = 1
    intLineWidth = 1
    intSpraySteps = 100
    lngPicNewWidth = 221 * Screen.TwipsPerPixelX
    lngPicNewHeight = 173 * Screen.TwipsPerPixelY
    
End Sub

Private Sub ReadINIFile()
    
    If Dir(App.Path & "\Optionen.ini") = "" Then 'Falls die Datei nicht vorhanden ist, soll sie neu erstellt werden.
NewFile:
        Open App.Path & "\Optionen.ini" For Output As #1
            Print #1, "[Files]"
            Print #1, "File1="
            Print #1, "File2="
            Print #1, "File3="
            Print #1, "File4="
            Print #1, ""
            Print #1, "[Main]"
            Print #1, "BackColor=" & vbBlack
            Print #1, "ForeColor=" & vbWhite
            Print #1, ""
            Print #1, "[Miscellaneous]"
            Print #1, ""
            Print #1, "[NewPic]"
            Print #1, "FormColor=" & vbWhite
            Print #1, "Height=0"
            Print #1, "Width=0"
            Print #1, "Unit=0"
            Print #1, ""
            Print #1, "[Options]"
            Print #1, "AskClearCB=1"
            Print #1, "CapMouse=1"
            Print #1, "ClearCB=0"
            Print #1, "ShowInfoDialog=1"
            Print #1, "ShowSplash=1"
            Print #1, ""
            Print #1, "[Properties]"
            Print #1, "FrameIndex=0"
            Print #1, ""
            Print #1, "[Screenshot]"
            Print #1, "ScreenShotDo=1"
            Print #1, "ScreenShotKind=1"
            Print #1, "ScreenShotTime=5"
        Close #1
            With typINIValue
                .bytAskClearCB = 0
                .bytCapMouse = 1
                .bytDeleteClipBoard = 0
                .bytShowSplash = 1
                .intScaleIndex = 0
                .lngBGColor = vbWhite
                .lngHeight = 0
                .lngWidth = 0
            End With
                Exit Sub
    Else
        If CheckINIValue("Main", "BackColor", True, 8, False) = False Then
            GoTo errError
        ElseIf CheckINIValue("Main", "ForeColor", True, 8, False) = False Then
            GoTo errError
        ElseIf CheckINIValue("NewPic", "FormColor", True, 8, False) = False Then
            GoTo errError
        ElseIf CheckINIValue("NewPic", "Height", True, 5, False) = False Then
            GoTo errError
        ElseIf CheckINIValue("NewPic", "Width", True, 5, False) = False Then
            GoTo errError
        ElseIf CheckINIValue("NewPic", "Unit", True, 1, False) = False Then
            GoTo errError
        ElseIf CheckINIValue("Options", "AskClearCB", True, 1, True) = False Then
            GoTo errError
        ElseIf CheckINIValue("Options", "CapMouse", True, 1, True) = False Then
            GoTo errError
        ElseIf CheckINIValue("Options", "ClearCB", True, 1, True) = False Then
            GoTo errError
        ElseIf CheckINIValue("Options", "ShowInfoDialog", True, 1, True) = False Then
            GoTo errError
        ElseIf CheckINIValue("Options", "ShowSplash", True, 1, True) = False Then
            GoTo errError
        ElseIf CheckINIValue("Properties", "FrameIndex", True, 2, False) = False Then
            GoTo errError
        ElseIf CheckINIValue("Screenshot", "ScreenShotKind", True, 1, False) = False Then
            GoTo errError
        ElseIf CheckINIValue("Screenshot", "ScreenShotTime", True, 2, False) = False Then
            GoTo errError
        ElseIf CheckINIValue("Screenshot", "ScreenShotDo", True, 1, False) = False Then
            GoTo errError
        End If
        
        With typINIValue
            .bytAskClearCB = GetINIString(App.Path & "\Optionen.ini", "Options", "AskClearCB")
            .bytCapMouse = GetINIString(App.Path & "\Optionen.ini", "Options", "CapMouse")
            .bytDeleteClipBoard = GetINIString(App.Path & "\Optionen.ini", "Options", "ClearCB")
            .bytFrameIndex = GetINIString(App.Path & "\Optionen.ini", "Properties", "FrameIndex")
            .bytShowInfos = GetINIString(App.Path & "\Optionen.ini", "Options", "ShowInfoDialog")
            .bytShowSplash = GetINIString(App.Path & "\Optionen.ini", "Options", "ShowSplash")
            .intScaleIndex = GetINIString(App.Path & "\Optionen.ini", "NewPic", "Unit")
            .lngBGColor = GetINIString(App.Path & "\Optionen.ini", "NewPic", "FormColor")
            .lngHeight = GetINIString(App.Path & "\Optionen.ini", "NewPic", "Height")
            .lngMDIColor(0) = GetINIString(App.Path & "\Optionen.ini", "Main", "ForeColor")
            .lngMDIColor(1) = GetINIString(App.Path & "\Optionen.ini", "Main", "BackColor")
            .lngWidth = GetINIString(App.Path & "\Optionen.ini", "NewPic", "Width")
        End With
        
        bytScreenShotDo = GetINIString(App.Path & "\Optionen.ini", "Screenshot", "ScreenshotDo")
        bytScreenShotKind = GetINIString(App.Path & "\Optionen.ini", "Screenshot", "ScreenshotKind")
        bytScreenShotTime = GetINIString(App.Path & "\Optionen.ini", "Screenshot", "ScreenshotTime")
        
    End If

    Exit Sub
    
errError:
        MsgBox "Die Datei Optionen.ini enthlt ein fehlerhafter Eintrag. Der Fehler wird beim klicken auf OK automatisch behoben.", vbInformation, "Fehler:"
            GoTo NewFile
                
End Sub

Private Function CheckSystemFiles() As Boolean

    Dim bytCount As Byte
    Dim strFileName(0 To 4) As String
    
    CheckSystemFiles = True 'Muss sein, da es sonst immer auf FALSE ist
    
    strFileName(0) = "comdlg32.dll"
    strFileName(1) = "gdi32.dll"
    strFileName(2) = "user32.dll"
    strFileName(3) = "rasapi32.dll"
    strFileName(4) = "shell32.dll"
    
    For bytCount = 0 To 4
    If Len(Dir(GetSystemDirectory & "\" & strFileName(bytCount))) = 0 Then
            CheckSystemFiles = False
                Exit Function
        End If
    Next

End Function

Private Sub SetRegistrySettings()

On Error GoTo errError

    CreateNewKey HKEY_LOCAL_MACHINE, "Software\Nyrox\Paint"
    SetKeyValue HKEY_LOCAL_MACHINE, "Software\Nyrox\Paint", "Path", App.Path & "\" & App.EXEName, REG_SZ
    SetKeyValue HKEY_LOCAL_MACHINE, "Software\Nyrox\Paint", "Starts", QueryValue(HKEY_LOCAL_MACHINE, "Software\Nyrox\Paint", "Starts") + 1, REG_SZ

    Exit Sub
    
errError:
    MsgBox "Nyrox Paint konnte nicht auf Ihren Registrierungseditor zugreifen.", vbCritical, "Fehler:"
        Exit Sub

End Sub

Private Function CheckINIValue(strPart As String, strValue As String, blnNumeric As Boolean, bytLenght As Byte, blnMachine As Boolean) As Boolean
    
    Dim strINIValue As String
    
    CheckINIValue = True 'Da ansonsten immer FALSE heraus kommt
    
    strINIValue = GetINIString(App.Path & "\Optionen.ini", strPart, strValue)
    
    If (blnNumeric) Then
        If IsNumeric(strINIValue) = False Then
            CheckINIValue = False
            Exit Function
        End If
    End If

    If Len(strINIValue) > bytLenght Then
        CheckINIValue = False
        Exit Function
    End If

    If (blnMachine) Then
        If strINIValue <> "0" And strINIValue <> "1" Then
            CheckINIValue = False
            Exit Function
        End If
    End If

End Function

Public Sub StatusText(strText As String)

    mdiMain.stbBar.Panels(1).Text = strText
    mdiMain.stbBar.Panels(1).ToolTipText = strText

End Sub
Public Function GetSystemDirectory() As String
    Dim i As Long
    Dim Puffer As String
    Puffer = Space$(255)
    i = GetSystemDirectoryA(Puffer, 255)
    GetSystemDirectory$ = Left$(Puffer, i)
End Function
